//Options.h
//Brent Gunning
//Copyright 2002 All Rights Reserved

//stores all the defines needed to run the game. change
//these values to easily change the game

//define the file
#ifndef OPTIONS_H
#define OPTIONS_H

//window data
#define WINDOW_TITLE "Wave Runner 3D"
#define WINDOW_STARTPOS_X 0
#define WINDOW_STARTPOS_Y 0

//device data
#define CLEAR_COLOR D3DCOLOR_ARGB(255,100,100,100)
#define VIEW_WIDTH 1024
#define VIEW_HEIGHT 768
#define WINDOWED false

//direction of the wind
#define WIND_DIRECTION D3DXVECTOR3(0.2f,0,0)

//various leaf information
#define LEAF_SIZE 0.8f
#define LEAF_TEXTURE "data/leaftexture.bmp"
#define LEAF_STARTCOLOR D3DXCOLOR(1,0.3f,0,0.5f)
#define LEAF_ENDCOLOR D3DXCOLOR(1,0,0,0.5f)
#define LEAF_STARTBOUNDING D3DXVECTOR3(1,1,1)
#define LEAF_WEIGHT 0.01f
#define LEAF_LIFETIME 300
#define NUM_LEAVES 150

//info for the trees
#define TREE_SIZE 10.0f
#define TREE_FILE "data/trees.ms3d"
#define TREE_TEXTURE "data/treetexture.bmp"

//water data
#define WATER_HEIGHT -2.0f
#define WATER_LENGTH 500.0f
#define WATER_WIDTH 500.0f
#define WATER_COLOR D3DCOLOR_ARGB(255,255,255,255);
#define NUM_WATER_LENGTH_WRAPS 15
#define NUM_WATER_WIDTH_WRAPS 15
#define WATER_TEXTURE "data/water.bmp"

//ocean floor defines
#define FLOOR_HEIGHT -4.9f
#define FLOOR_LENGTH 500.0f
#define FLOOR_WIDTH 500.0f
#define NUM_FLOOR_LENGTH_WRAPS 3
#define NUM_FLOOR_WIDTH_WRAPS 3
#define FLOOR_TEXTURE "data/sand.bmp"

//about the level
#define LEVEL_FILE "level.ms3d"
#define LEVEL_REPATH "data/"
#define LEVEL_TEST_BOUNDING_BOX true
#define LEVEL_TEST_BOUNDING_SPHERE false

//the skybox information
#define SKYBOX_SIZE D3DXVECTOR3(500,500,500)
#define SKYBOX_TOP "data/skybox_top.bmp"
#define SKYBOX_BOTTOM "data/skybox_bottom.bmp"
#define SKYBOX_FRONT "data/skybox_front.bmp"
#define SKYBOX_BACK "data/skybox_back.bmp"
#define SKYBOX_LEFT "data/skybox_left.bmp"
#define SKYBOX_RIGHT "data/skybox_right.bmp"

//the level for collisions on the terrain
#define COLLISION_LEVEL "data/levelboundings.ms3d"

//control defines
#define INITIAL_POSITION D3DXVECTOR3(-3,WATER_HEIGHT,-10)
#define INITIAL_ANGLE 0
#define RIGHT_INCREMENT 3.0f
#define LEFT_INCREMENT 3.0f
#define INITIAL_SPEED 0.0f
#define MAX_SPEED 0.5f
#define MIN_SPEED 0.0f
#define SPEED_INCREMENT 0.02f
#define WIND D3DXVECTOR3(0.1f,0.0f,0.0f);

//button info
#define LEFT_BUTTON DIK_LEFT
#define RIGHT_BUTTON DIK_RIGHT
#define UP_BUTTON DIK_UP
#define ESCAPE_BUTTON DIK_ESCAPE

//collision defines
#define RAY_CAST_HEIGHT 1000.0f

//camera defines
#define CAMERA_DISTANCE 3.0f

//volcano defines
#define VOLCANO_END_COLOR D3DXCOLOR(0.5f,0.2f,0.0f,1.0f) 
#define VOLCANO_START_COLOR D3DXCOLOR(0.1f,0.0f,0.0f,1.0f)
#define VOLCANO_WEIGHT 0.04f
#define VOLCANO_WEIGHT_RAND 0.0001f
#define VOLCANO_SIZE_X 2.5f
#define VOLCANO_SIZE_Y 2.5f
#define VOLCANO_LIFETIME 100
#define NUM_VOLCANO_PARTICLES 2000
#define VOLCANO_POSITION D3DXVECTOR3(-40,30,10)
#define VOLCANO_VELOCITY D3DXVECTOR3(0,1,0)
#define VOLCANO_POSITION_RAND D3DXVECTOR3(5,5,5)
#define VOLCANO_VELOCITY_RAND D3DXVECTOR3(0.3f,0.001f,0.3f)

#endif