//main.cpp
//Brent Gunning
//Copyright 2002 All Rights Reserved

//main.cpp is the main file. all it does it initialize the window and call the sub
//functions of the main game class

#include "main.h"

//winproc.
//handles messages generated from the window
LRESULT CALLBACK WinProc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_DESTROY://the window is being destroyed
		{
			PostQuitMessage(0);//tell the app to quit
			return(0);
		}break;
	case WM_PAINT://need to repaint the window. windows will complain if it isn't here
		{
			PAINTSTRUCT ps;//paint it defaultly
			HDC hdc=BeginPaint(hwnd,&ps);
			EndPaint(hwnd,&ps);
		}break;
	}
	//give other messages to the default window message handler
	return(DefWindowProc(hwnd,uMsg,wParam,lParam));
}

//winmain
//main in windows
int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nShowCmd)
{
	//set the global instance
	hInstMain=hInstance;

    //create the window class structure, register it, and then create the window
    WNDCLASSEX wcx={sizeof(WNDCLASSEX),CS_CLASSDC,WinProc,0,0,
					hInstMain,0,0,0,0,WINDOW_TITLE,0};
    RegisterClassEx(&wcx);
    hWndMain=CreateWindow(WINDOW_TITLE,WINDOW_TITLE,WS_OVERLAPPEDWINDOW|WS_VISIBLE,
		WINDOW_STARTPOS_X,WINDOW_STARTPOS_Y,VIEW_WIDTH,VIEW_HEIGHT,0,0,hInstMain,0);

	//check if it actually created the window
	if(hWndMain==0) return(0);

	//initialize the game. if it failed, quit
	if(game.Initialize(hWndMain)==false) return(0);

	//message pump
	MSG msg;
	while(true)
	{
		//check if there's a message
		if(PeekMessage(&msg,0,0,0,PM_REMOVE))
		{
			if(msg.message==WM_QUIT) break;//make sure we arn't quitting
			TranslateMessage(&msg);//translate the virtual keys
			DispatchMessage(&msg);//send the message to winproc
		}
		//run main game loop
		game.Process();
	}
	//release game memory
	game.Destroy();

	return(msg.wParam);
}