//CW3DCamera.h
//Brent Gunning
//Copyright 2002 All Rights Reserved

//encapsulates the functionality
//of modifying the view and projection matrices

//define the file
#ifndef CW3DCAMERA_H
#define CW3DCAMERA_H

//include d3d8 files
#include "d3d8.h"
#include "d3dx8.h"

//the main camera class
class CW3DCamera
{
public:
	//constructor/deconstructor
	//sets matrix identities
	CW3DCamera();
	~CW3DCamera();

	//returns the matrices needed
	D3DXMATRIX GetViewMatrix() {return(m_matView);}
	D3DXMATRIX GetProjectionMatrix() {return(m_matProj);}

	//set the matrices
	void SetViewMatrix(D3DXMATRIX* mat) {m_matView=*mat;}
	void SetProjectionMatrix(D3DXMATRIX* mat) {m_matProj=*mat;}

	//Initializes the view and projection matrices
	void Initialize(int Width,int Height,D3DXVECTOR3 vecPos,D3DXVECTOR3 vecRot);

	//moves and rotates the camera
	void Move(D3DXVECTOR3 vecTrans) {m_vecPos+=vecTrans;}
	void Rotate(D3DXVECTOR3 vecRot) {m_vecRot+=vecRot;}

	//sets the position and rotation
	void SetPosition(D3DXVECTOR3 vecPos) {m_vecPos=vecPos;}
	void SetRotation(D3DXVECTOR3 vecRot) {m_vecRot=vecRot;}

	//returns the position and rotation
	D3DXVECTOR3 GetPosition() {return(m_vecPos);}
	D3DXVECTOR3 GetRotation() {return(m_vecRot);}

	//updates the matrices
	void Update();

	//assigns the camera to the device
	HRESULT Assign(IDirect3DDevice8* pDevice);
protected:
	//the view and projection matrices
	D3DXMATRIX m_matView,m_matProj;

	//position and rotation
	D3DXVECTOR3 m_vecPos,m_vecRot;

	//error variable
	HRESULT hr;
};

#endif