//CW3DDevice.h
//Brent Gunning
//Copyright 2002 All rights reserved

//encapsulates the "basic" functionality of
//a direct3d device into a single class. 
//note: i'm only using a class because it works
//better than functions. my oo style isn't great

//define the file so no overwrites
#ifndef CW3DDEVICE_H
#define CW3DDEVICE_H

//include d3d files
#include "d3d8.h"
#include "d3dx8.h"

//the actual class
class CW3DDevice
{
public:
	//constructor
	//sets all values in structure
	//to 0(which can equal NULL)
	CW3DDevice();
	//deconstructor
	//calls release on the whole device
	~CW3DDevice();

	//creates a basic device
	//by setting the bool windowed to true or false,
	//you can make it either windowed or full screen
	HRESULT Initialize(HWND hWnd,int iWidth,int iHeight,bool bWindowed);

	//begins, ends, and presents a scene. 
	//the functions are supposed to mimic
	//the actual device funcitons
	HRESULT BeginScene();
	HRESULT Present();
	HRESULT EndScene();

	//this will get called if the device is lost
	HRESULT Reset();

	//releases memory for the device
	HRESULT Destroy();
	
	//it returns a device pointer
	IDirect3DDevice8* GetDevice();
protected:
	//d3d interfaces
	IDirect3DDevice8* m_pDevice;
	IDirect3D8* m_pD3D;

	//structures for device settings
	D3DPRESENT_PARAMETERS m_PresentParams;
	D3DDISPLAYMODE m_DisplayMode;
	
	//used to hold errors for functions
	HRESULT hr;
};

#endif
