//CW3DFrustum.h
//Brent Gunning
//Copyright 2002 All Rights Reserved

//encapsulates the functionality of a viewing
//frustum in direct3d. it uses the plane class
//for the viewing frustum planes instead of d3d's 
//plane

//define the file
#ifndef CW3DFRUSTRUM_H
#define CW3DFRUSTRUM_H

//include planes
#include "CW3DPlane.h"
#include "d3d8.h"
#include "d3dx8.h"

//defines for plane sides
#define PLANESIDE_LEFT 0
#define PLANESIDE_RIGHT 1
#define PLANESIDE_TOP 2
#define PLANESIDE_BOTTOM 3
#define PLANESIDE_NEAR 4
#define PLANESIDE_FAR 5

//main frustrum class
class CW3DFrustum
{
public:
	//constructor/deconstructor
	//like most others, releases memory and sets defaults
	CW3DFrustum();
	~CW3DFrustum();
	//creates the viewing frustum based on the matrices it extracts
	//the mat combined matrices are the view, world, and projection matrices
	//all multiplied together
	HRESULT Initialize(D3DXMATRIX matCombined);

	//checks if a point is in the frustum
	bool IsPointInFrustum(float x,float y, float z);

	//checks if a cube is in the frustum
	bool IsBoxInFrustum(float x,float y,float z,float width,float height,float depth);

	//checks if a sphere is in the frustum
	bool IsSphereInFrustum(float x,float y,float z,float radius);

	//releases the frustum
	HRESULT Destroy();
protected:
	//error variables
	HRESULT hr;

	//viewing planes
	CW3DPlane m_Planes[6];
};

#endif