//MD2Format.h
//Brent Gunning
//Copyright 2002 All Rights Reserved

//holds the structures needed to render and load
//a .md2(quake2) file

//define the file
#ifndef MD2FORMAT_H
#define MD2FORMAT_H

//include files
#include "d3d8.h"
#include "d3dx8.h"

//the md2 structures
struct sMD2Header
{
	int Identification;		//used to identify the file
	int Version;			//the file version which must be 8
	int SkinWidth;
	int SkinHeight;
	int FrameSize;
	int NumSkins;			//number of textures
	int NumVertices;		//number of vertices
	int NumTexCoords;		//tex coords amount
	int NumTriangles;		//number of faces in model
	int NumGLCommands;
	int NumFrames;			//number of frames of animation
	int SkinOffset;			//offset in file for skin data
	int TexCoordOffset;		//offset for tex coords
	int TriangleOffset;		//face offset
	int FrameOffset;		//animation frames offset
	int GLCommandsOffset;	//offset in file for opengl commands (not needed for d3d)
	int FileEndOffset;		//end of file
};
struct sMD2AliasTriangle
{
	BYTE Vertex[3];
	BYTE NormalIndex;
};
struct sMD2Triangle
{
	float Vertex[3];
	float Normal[3];
};
struct sMD2Face
{
	short VertexIndices[3];
	short TextureIndices[3];
};
struct sMD2TexCoord
{
	short tu,tv;
};
struct sMD2AliasFrame
{
	float Scale[3];
	float Translation[3];
	char Name[16];
	sMD2AliasTriangle AliasVertices[1];
};
struct sMD2Frame
{
	char Name[16];
	sMD2Triangle* pVertices;
};
struct sMD2Skin
{
	char Name[64];
};

#endif