//CW3DControl.h
//Brent Gunning
//Copyright 2002 All Rights Reserved

//define the file
#ifndef CW3DCONTROL_H
#define CW3DCONTROL_H

//include files
#include "../../Options.h"
#include "../../w3d engine/headers/CW3DInput.h"
#include "../../w3d engine/headers/CW3DMilkshapeModel.h"
#include "math.h"

//defines to convert degrees to radians using the pi value 
#define PI 3.141592653589793238462643383279
#define DegToRad(deg) ((deg/180.0f)*PI)

//the main control class for controlling the character
class CW3DControl
{
public:
	//constructor/deconstructor
	//sets defaults and releases memory
	CW3DControl();
	~CW3DControl();

	//loads up the bounding level for collisions with the terrain.
	//then it sets up the input and gets the controls all ready
	HRESULT Initialize(HWND hWnd);

	//releases the class's memory
	HRESULT Destroy();

	//processes the input, speed, position, and angle values
	//also counts the collisions too. oh yea, it also adds
	//the wind values to the position
	HRESULT Process();

	//returns values as pointers
	void GetValues(D3DXVECTOR3 &pPosition,float &pAngle,BOOL &Up,BOOL &Left,BOOL &Right);
protected:
	//input class for retrieving input
	CW3DInput m_Input;

	//triangles for testing
	D3DXVECTOR3* m_pTriangles[3];
	int m_NumTriangles;

	//position and angle
	D3DXVECTOR3 m_vecPos;
	D3DXVECTOR3 m_vecPrevPos;
	float m_Angle;

	//buttons
	BOOL m_bUp,m_bLeft,m_bRight;

	float m_CosLookup[360];
	float m_SinLookup[360];

	float m_Speed;

	//error variable
	HRESULT hr;
};

#endif