//CW3DGame.h
//Brent Gunning
//Copyright 2002 All Rights Reserved

//here we define the basis of the whole game. 
//it is all encapsulated inside three functions:
//initialize, process, and destroy.

//define the file so that it isn't repeated
#ifndef CW3DGAME_H
#define CW3DGAME_H

//include the device file
#include "../../w3d engine/headers/CW3DDevice.h"
//include the camera and frustrum classes for
//modifications of the Direct3D transformation matrices
#include "../../w3d engine/headers/CW3DCamera.h"
//include the control class for input
#include "CW3DControl.h"
//include the world class. this includes sub classes for
//rendering the other parts of the world
#include "CW3DWorld.h"
#include "../../Options.h"

//the actual, the one and only, CW3DGame
class CW3DGame
{
public:
	//this will create and initialize all
	//game objects. it is called as soon
	//as the window is created in main.cpp
	bool Initialize(HWND hWnd);

	//processes the data. you could also call
	//this the main game loop function. it does
	//everything. there is no reason to return 
	//a value.
	void Process();

	//cleans up and releases memory. it's called just
	//before the program quits
	void Destroy();
protected:
	//the device for rendering
	CW3DDevice m_Device;

	//the camera
	CW3DCamera m_Camera;

	//the control object
	CW3DControl m_Control;

	//the actual world to render
	CW3DWorld m_World;

	//handle to the window. stored from the init function
	HWND m_hWnd;
};

#endif 