//CW3DWater.h
//Brent Gunning
//Copyright 2002 All Rights Reserved

//creates and processes water used to create the ocean. another part of the water 
//which this encapsulates is the water floor. this can't
//be done in a modeler because the water floor must be a texture that is setup
//so that it tiles it across plane

//define the file
#ifndef CW3DWATER_H
#define CW3DWATER_H

//include files
#include "d3d8.h"
#include "d3dx8.h"
#include "../../w3d engine/headers/VertexFormats.h"
#include "../../Options.h"

//define the vertex
#define WATERVERTEX VERTEX_XYZ_NRM_DIF_TEX
#define D3DFVF_WATERVERTEX D3DFVF_VERTEX_XYZ_NRM_DIF_TEX

//the water class
class CW3DWater
{
public:
	//constructor/deconstructor
	//sets defaults and releases memory
	CW3DWater();
	~CW3DWater();

	//initializes the water. it sets up the vertex buffers for rendering
	///returns an hresult for error testing
	HRESULT Initialize(IDirect3DDevice8* pDevice);

	//renders the waves and floor. uses the vertex buffer
	HRESULT Render(IDirect3DDevice8* pDevice);

	//releses the class's memory
	HRESULT Destroy();
protected:
	//vertex buffer for water and ground plane
	IDirect3DVertexBuffer8* m_VertexBuffer;
	int m_NumVerts;

	//the textures for the water
	IDirect3DTexture8* m_WaterTexture;
	IDirect3DTexture8* m_FloorTexture;

	//error variable
	HRESULT hr;
};

#endif
